---
title: DataTransfer.getData()
slug: Web/API/DataTransfer/getData
tags:
  - API
  - HTML DOM
  - Method
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>DataTransfer.getData()</code></strong> method retrieves drag data (as a {{domxref("DOMString")}}) for the specified type. If the drag operation does not include data, this method returns an empty string.</span></p>

<p>Example data types are <code>text/plain</code> and <code>text/uri-list</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>dataTransfer</var>.getData(format);
</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><code>format</code></dt>
 <dd>A {{domxref("DOMString")}} representing the type of data to retrieve.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt>{{domxref("DOMString")}}</dt>
 <dd>A {{domxref("DOMString")}} representing the drag data for the specified <code>format</code>. If the drag operation has no data or the operation has no data for the specified <code>format</code>, this method returns an empty string.</dd>
</dl>

<h3 id="Caveats">Caveats</h3>

<dl>
 <dt>Data availability</dt>
 <dd>The <a href="https://www.w3.org/TR/2011/WD-html5-20110113/dnd.html#drag-data-store-mode">HTML5 Drag and Drop Specification</a> dictates a <code>drag data store mode</code>. This may result in unexpected behavior, being <strong><code>DataTransfer.getData()</code></strong> not returning an expected value.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows the use of the {{domxref("DataTransfer")}} object's {{domxref("DataTransfer.getData()","getData()")}} and {{domxref("DataTransfer.setData()","setData()")}} methods.</p>

<h3 id="HTML_Content">HTML Content</h3>

<pre class="brush: html">&lt;div id="div1" ondrop="drop(event)" ondragover="allowDrop(event)"&gt;
    &lt;span id="drag" draggable="true" ondragstart="drag(event)"&gt;drag me to the other box&lt;/span&gt;
&lt;/div&gt;
&lt;div id="div2" ondrop="drop(event)" ondragover="allowDrop(event)"&gt;&lt;/div&gt;
</pre>

<h3 id="CSS_Content">CSS Content</h3>

<pre class="brush: css">#div1, #div2 {
    width:100px;
    height:50px;
    padding:10px;
    border:1px solid #aaaaaa;
}
</pre>

<h3 id="JavaScript_Content">JavaScript Content</h3>

<pre class="brush: js">function allowDrop(allowdropevent) {
    allowdropevent.target.style.color = 'blue';
    allowdropevent.preventDefault();
}

function drag(dragevent) {
    dragevent.dataTransfer.setData("text", dragevent.target.id);
    dragevent.target.style.color = 'green';
}

function drop(dropevent) {
    dropevent.preventDefault();
    var data = dropevent.dataTransfer.getData("text");
    dropevent.target.appendChild(document.getElementById(data));
    document.getElementById("drag").style.color = 'black';
}
</pre>

<h3 id="Result">Result</h3>

<p id="EmbedLiveSample('Example'_''_''_''_'WebAPIDataTransfergetData')">{{ EmbedLiveSample('Example', 600) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "interaction.html#dom-datatransfer-getdata", "getData()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "editing.html#dom-datatransfer-getdata", "getData()")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DataTransfer.getData")}}</p>

<h2 id="See_also">See also</h2>

<p>{{page("/en-US/docs/Web/API/DataTransfer", "See also")}}</p>
